<template>
    <div>
        <div
            :class="[show?'overlay-enter-active':'overlay-out-active','overlay']"
            :style="isDisplay?'display:block;':'display:none'"
            @click="onCancel"
        ></div>
        <div
            :class="[show?'popup-slide-top-enter':'popup-slide-top-leave-active','popup']"
            :style="isDisplay?'display:block;':'display:none'"
            style="height:45%;z-index: 2025;"
        >
            <div class="popup-bar">
                <div class="cancel" @click="onCancel">取消</div>
                <div class="bar-txt">请输入验证码</div>
                <div class="confirm" @click="onConfirm">确定</div>
            </div>
            <div class="popup-content">
                <div class="popup-content-title">
                    <div class="txt">验证码已发送到您注册手机</div>
                    <div class="phone">{{phone}}</div>
                </div>
                <div class="input-container">
                    <label class="verification-input hairline--surround">
                        <div class="">{{code[0]}}</div>
                        <div class="van-hairline--left">{{code[1]}}</div>
                        <div class="van-hairline--left">{{code[2]}}</div>
                        <div class="van-hairline--left">{{code[3]}}</div>
                        <div class="van-hairline--left">{{code[4]}}</div>
                        <div class="van-hairline--left">{{code[5]}}</div>
                        <input
                            id="verificationCode"
                            :focus="true"
                            v-model.trim="code"
                            type="number"
                            maxlength="6"
                        >
                    </label>
                </div>
                <div class="resend">
                    <div class="status-txt" v-if="time!==0&&!timeStart">{{time}}S后可重新发送</div>
                    <div class="status-txt" v-if="timeStart" @click="event().sendCode()">重新发送</div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
export default {
  data() {
    return {
      //   show:false,
      code: "",
      Interval: null,
      timeStart: true,
      time: 60,
      isDisplay: false
    };
  },
  props: {
    show: {
      type: Boolean,
      default: false
    },
    phone:{
      type:String,
      default:''
    }
  },
  watch: {
    time: function(newValue, oldValue) {
      if (newValue <=0) {
        clearInterval(this.Interval);
        this.timeStart = true;
        this.time = 60
      }
    },
    show: {
      deep: true,
      handler(newValue) {
        if (newValue) {
            this.isDisplay = true;
        } else {
          setTimeout(() => {
            this.isDisplay = false;
          }, 300);
        }
      }
    },
    code(newvalue){
      this.$emit('getCode',newvalue)
    }
  },
  onLoad() {},
  methods: {
    onCancel() {
      this.$emit("onCancel", this.show);
    },
    onConfirm() {
      this.$emit("onConfirm", this.show);
    },
    handler() {
      return {
        countDown: () => {
          this.timeStart = false;
          this.Interval = setInterval(() => {
            this.time--;
          }, 1000);
        }
      };
    },
    event() {
      return {
        sendCode: () => {
          // this.handler().countDown();
          this.code = ''
          this.$parent.network().runApiToSendCode()
        }
      };
    }
  }
};
</script>

<style lang="scss" scoped>
.overlay {
  position: fixed;
  top: 0;
  left: 0;
  z-index: 1;
  width: 100%;
  height: 100%;
  background-color: rgba(0, 0, 0, 0.7);
}
.overlay-enter-active {
  animation: 0.3s fade-in;
}
.overlay-out-active {
  animation: 0.3s fade-out;
}
@keyframes fade-in {
  from {
    opacity: 0;
  }
  to {
    opacity: 1;
  }
}
@keyframes fade-out {
  from {
    opacity: 1;
  }
  to {
    opacity: 0;
  }
}
.popup-slide-top-leave-active {
  transform: translate3d(0, 100%, 0);
}
.popup-slide-top-enter {
  transform: translate3d(0, 0, 0);
}
.popup {
    overflow: hidden;
  bottom: 0;
  left: 0;
  width: 100%;
  position: fixed;
  max-height: 100%;
  overflow-y: auto;
  background-color: #fff;
  transition: transform 0.3s ease-out;
  .popup-bar {
    display: flex;
    align-items: center;
    justify-content: space-between;
    padding: 34rpx 70rpx;
    border-bottom: 1rpx solid rgba(0, 0, 0, 0.4);
    .cancel,
    .confirm,
    .bar-txt {
      font-size: 28rpx;
      font-family: STXihei;
      color: #727171;
    }
    .bar-txt {
      color: #333 !important;
    }
  }
  .popup-content {
    position: relative;
    width: 600rpx;
    box-sizing: border-box;
    margin: 0 auto;
    text-align: center;
    padding: 60rpx 0rpx;
    .popup-content-title {
      margin-bottom: 52rpx;
      .txt,
      .phone {
        font-size: 28rpx;
        font-family: STXihei;
        color: #727171;
      }
      .txt {
        margin-bottom: 30rpx;
      }
    }
    .input-container {
      .verification-input {
        position: relative;
        display: flex;
        width: 100%;
        height: 87rpx;
        cursor: pointer;
      }
      input {
        box-sizing: border-box;
        text-align: left;
        position: absolute;
        top: 0;
        left: -100%;
        width: 200%;
        height: 300%;
        background-color: transparent;
        color: transparent;
        caret-color: transparent;
        opacity: 0;
      }
      .verification-input div {
        position: relative;
        -webkit-box-flex: 1;
        -webkit-flex: 1;
        flex: 1;
        height: 100%;
        font-size: 40rpx;
        line-height: 87rpx;
        text-align: center;
        background-color: #fff;
      }
      .verification-input::after {
        border-radius: 6rpx;
      }
      [class*="hairline"]::after {
        position: absolute;
        box-sizing: border-box;
        content: " ";
        pointer-events: none;
        top: -50%;
        right: -50%;
        bottom: -50%;
        left: -50%;
        border: 0 solid #727171;
        -webkit-transform: scale(0.5);
        transform: scale(0.5);
      }
      .hairline--surround::after {
        border-width: 1rpx;
      }
      .van-hairline--left::after {
        border-left-width: 1rpx;
      }
    }
    .resend {
      position: absolute;
      z-index: 10;
      width: 100%;
      text-align: center;
      margin-top: 40rpx;
      .status-txt {
        font-size: 28rpx;
        font-family: STXihei;
        color: rgba(0, 0, 0, 0.4);
      }
    }
  }
}
</style>